
		*=$4000

_NOP		=0
_END		=1
_NOTE		=2
_AD		=3
_SR		=4
_CR		=5
_SAW		=6
_2NOTE		=7
_2AD		=8
_2SR		=9
_2CR		=10
_2SAW		=11
_DEPTH		=12
_VRESTART	=13
_REL		=14
_2REL		=15
_2TRI		=16
_VOL		=17
_PUL		=18
_SQ		=_PUL
_2PUL		=19
_2SQ		=_2PUL
_PW		=20
_FILTER		=21
_CUTO		=22
_CUTOD		=23
_VSPEED		=24
_RESET		=25
_PWD		=26
_TRANSPH	=27
_TRANSPDH	=28
_TRANSPDL	=29
_TRANSPL	=30
_3ARP		=31
_3AD		=32
_3SR		=33
_3SAW		=34
_3REL		=35
_3TRI		=36
_TRI		=37
_2DEPTH		=38
_JUMP		=39
_TEMPO		=40
_BNOTE		=41
_BSAW		=42
_BREL		=43
_BSR		=44
_3CR		=45
_CHORD		=46
_CREL		=47
_3NOTE		=48
_3DEPTH		=49
_2VSPEED	=50
_3VSPEED	=51
_TR		=52
_ANOTE		=53
_NOI		=54
_3SQ		=55
_2PWD		=56
_3PWD		=57

seqptr		=$90
tmpjmp		=$92

		jmp	initroutine

playroutine:	.(
		.(
		lda	playflag
		beq	write_sid
		.)
		.(
		dec	timeleft
		bne	write_sid
		.)
getcmd		.(
		jsr	getbyte
		asl
		tax
		lda	cmdtable,x
		sta	tmpjmp
		lda	cmdtable+1,x
		sta	tmpjmp+1
		jmp	(tmpjmp)
		.)

postcmd		.(
		jsr	getbyte
		cmp	#0
		beq	getcmd
		sta	timeleft
		.)
write_sid	.(
		lda	vibrdelay
		cmp	#0
		beq	sk
		dec	vibrdelay
		bne	sk
		lda	dvibrdepth
		sta	vibrdepth
		lda	#0
		sta	vibrpos
		sta	vibrpos2
		sta	vibrpos3
sk		.)
		;.(
		;inc	trpos
		;ldx	trpos
		;lda	trscheme,x
		;bpl	s1
		;lda	#0
		;sta	trpos
		;lda	trscheme
;s1		;tax
		;lda	trnotes,x
		;tax
		;lda	lofreq,x
		;sta	basefreq
		;lda	hifreq,x
		;sta	basefreq+1
		;.)
		;.(
		;inc	trpos2
		;ldx	trpos2
		;lda	trscheme2,x
		;bpl	s1
		;lda	#0
		;sta	trpos2
		;lda	trscheme2
;s1		;tax
		;lda	trnotes,x
		;tax
		;lda	lofreq,x
		;sta	basefreq2
		;lda	hifreq,x
		;sta	basefreq2+1
		;.)
		;.(
		;inc	trpos3
		;ldx	trpos3
		;lda	trscheme3,x
		;bpl	s1
		;lda	#0
		;sta	trpos3
		;lda	trscheme3
;s1		;tax
		;lda	trnotes,x
		;tax
		;lda	lofreq,x
		;sta	basefreq3
		;lda	hifreq,x
		;sta	basefreq3+1
		;.)
		.(
		ldx	vibrpos
		lda	sinvibr,x
		ldy	vibrdepth
shl		dey
		beq	shd
		lsr
		jmp	shl
shd		sta	vibroffs
		txa
		clc
		adc	vibrdelta
		sta	vibrpos
		.)
		.(
		ldx	vibrpos2
		lda	sinvibr,x
		ldy	vibrdepth
shl		dey
		beq	shd
		lsr
		jmp	shl
shd		sta	vibroffs2
		txa
		clc
		adc	vibrdelta2
		sta	vibrpos2
		.)
		.(
		ldx	vibrpos3
		lda	sinvibr,x
		ldy	vibrdepth
shl		dey
		beq	shd
		lsr
		jmp	shl
shd		sta	vibroffs3
		txa
		clc
		adc	vibrdelta3
		sta	vibrpos3
		.)
		.(
		ldx	basefreq+1
		lda	basefreq
		;clc
		;adc	vibroffs
		;bcc	s0
		;inx
s0		clc
		adc	vibroffs
		bcc	s1
		inx
s1		clc
		adc	transpoffs
		bcc	s2
		inx
s2		pha
		txa
		clc
		adc	vibroffs+1
		;clc
		;adc	vibroffs+1
		clc
		adc	transpoffs+1
		sta	$d401
		pla
		sta	$d400
		.)
		.(
		lda	transpoffs
		clc
		adc	transpdelta
		sta	transpoffs
		lda	transpoffs+1
		adc	transpdelta+1
		sta	transpoffs+1
		.)
		.(
		ldx	basefreq2+1
		lda	basefreq2
		;clc
		;adc	vibroffs2
		;bcc	s0
		;inx
s0		clc
		adc	vibroffs2
		bcc	s1
		inx
s1		clc
		adc	transpoffs
		bcc	s2
		inx
s2		pha
		txa
		;clc
		;adc	vibroffs2+1
		clc
		adc	vibroffs2+1
		clc
		adc	transpoffs+1
		sta	$d408
		pla
		sta	$d407
		.)
		.(
		ldx	basefreq3+1
		lda	basefreq3
		;clc
		;adc	vibroffs3
		;bcc	s0
		;inx
s0		clc
		adc	vibroffs3
		bcc	s1
		inx
s1		clc
		adc	transpoffs
		bcc	s2
		inx
s2		pha
		txa
		;clc
		;adc	vibroffs3+1
		clc
		adc	vibroffs3+1
		clc
		adc	transpoffs+1
		sta	$d40f
		pla
		sta	$d40e
		.)

		.(
		lda	pwidth
		clc
		adc	pwidthd
		sta	pwidth
		pha
		lda	pwidth+1
		adc	pwidthd+1
		sta	pwidth+1
		and	#$07
		clc
		adc	#$04
		tax
		pla
		clc
		adc	#$00
		bcc	s1
		inx
s1		sta	$d402
		txa
		sta	$d403
		.)

		.(
		lda	pwidth2
		clc
		adc	pwidthd2
		sta	pwidth2
		pha
		lda	pwidth2+1
		adc	pwidthd2+1
		sta	pwidth2+1
		and	#$07
		clc
		adc	#$04
		tax
		pla
		clc
		adc	#$00
		bcc	s1
		inx
s1		sta	$d409
		txa
		sta	$d40a
		.)

		.(
		lda	pwidth3
		clc
		adc	pwidthd3
		sta	pwidth3
		pha
		lda	pwidth3+1
		adc	pwidthd3+1
		sta	pwidth3+1
		and	#$07
		clc
		adc	#$04
		tax
		pla
		clc
		adc	#$00
		bcc	s1
		inx
s1		sta	$d410
		txa
		sta	$d411
		.)

		.(
		lda	cutoff
		clc
		adc	cutoffd
		sta	cutoff
		lda	cutoff+1
		adc	cutoffd+1
		sta	cutoff+1
		sta	$d416
		.)
		rts

cmdtable	.word	c_nop,c_end
		.word	c_note,c_ad,c_sr,c_cr,c_saw
		.word	c_2note,c_2ad,c_2sr,c_2cr,c_2saw
		.word	c_depth,c_vrestart
		.word	c_rel,c_2rel
		.word	c_2tri
		.word	c_vol
		.word	c_pul,c_2pul,c_pw
		.word	c_filter,c_cuto,c_cutod
		.word	c_vspeed
		.word	c_reset
		.word	c_pwd
		.word	c_transph,c_transpdh,c_transpdl,c_transpl
		.word	c_3arp,c_3ad,c_3sr,c_3saw,c_3rel,c_3tri
		.word	c_tri,c_2depth,c_jump,c_tempo
		.word	c_bnote,c_bsaw,c_brel,c_bsr,c_3cr
		.word	c_chord,c_crel,c_3note,c_3depth
		.word	c_2vspeed,c_3vspeed
		.word	c_tr,c_anote,c_noi,c_3sq
		.word	c_2pwd,c_3pwd

c_nop		jmp	postcmd

c_end		lda	#0
		sta	playflag
		jmp	postcmd

c_note		.(
		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq
		sta	basefreq2
		sta	basefreq3
		lda	hifreq,x
		sta	basefreq+1
		sta	basefreq2+1
		sta	basefreq3+1
		lda	#6
		sta	vibrdepth
		lda	#4
		sta	vibrdelay
		jmp	postcmd
		.)

c_ad		jsr	getbyte
		sta	$d405
		sta	$d40c
		sta	$d413
		jmp	postcmd


c_sr		jsr	getbyte
		sta	$d406
		sta	$d40d
		sta	$d414
		jmp	postcmd

c_cr		jsr	getbyte
		sta	ctrlshadow
		sta	$d404
		jmp	postcmd

c_3cr		jsr	getbyte
		sta	ctrlshadow3
		sta	$d412
		jmp	postcmd

c_saw		lda	#$21
		sta	ctrlshadow
		sta	$d404
		jmp	postcmd

c_3sq		lda	#$41
		sta	ctrlshadow
		sta	$d412
		jmp	postcmd

c_noi		lda	#$81
		sta	ctrlshadow
		sta	$d404
		jmp	postcmd

c_2note		.(
		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq2
		lda	hifreq,x
		sta	basefreq2+1
		jmp	postcmd
		.)

c_3note		.(
		jsr	getbyte
		tax
		lda	lofreq-12,x
		sta	basefreq3
		lda	hifreq-12,x
		sta	basefreq3+1
		jmp	postcmd
		.)

c_bnote		.(
		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq
		lda	hifreq,x
		sta	basefreq+1
		lda	lofreq+12,x
		sta	basefreq2
		lda	hifreq+12,x
		sta	basefreq2+1
		jmp	postcmd
		.)

c_2ad		jsr	getbyte
		sta	$d40c
		jmp	postcmd

c_2sr		jsr	getbyte
		sta	$d40d
		jmp	postcmd

c_bsr		jsr	getbyte
		sta	$d406
		sta	$d40d
		jmp	postcmd

c_3ad		jsr	getbyte
		sta	$d413
		jmp	postcmd

c_3sr		jsr	getbyte
		sta	$d414
		jmp	postcmd

c_2cr		jsr	getbyte
		sta	ctrlshadow2
		sta	$d40b
		jmp	postcmd

c_2saw		lda	#$21
		sta	ctrlshadow2
		sta	$d40b
		jmp	postcmd

c_3saw		lda	#$21
		sta	ctrlshadow3
		sta	$d412
		jmp	postcmd

c_bsaw		lda	#$21
		sta	ctrlshadow2
		sta	ctrlshadow
		sta	$d40b
		sta	$d404
		jmp	postcmd

c_3tri		lda	#$11
		sta	ctrlshadow3
		sta	$d412
		jmp	postcmd

c_tri		lda	#$11
		sta	ctrlshadow
		sta	$d404
		jmp	postcmd

c_2tri		lda	#$11
		sta	ctrlshadow2
		sta	$d40b
		jmp	postcmd
	
c_depth		jsr	getbyte
		sta	dvibrdepth
		jmp	postcmd

c_2depth	jsr	getbyte
		sta	vibrdepth2
		jmp	postcmd

c_3depth	jsr	getbyte
		sta	vibrdepth3
		jmp	postcmd

c_vrestart	lda	#0
		sta	vibrpos
		jmp	postcmd

c_brel		lda	ctrlshadow2
		and	#$fe
		sta	$d40b
		;drop through

c_rel		lda	ctrlshadow
		and	#$fe
		sta	$d404
		sta	$d40b
		sta	$d412
		jmp	postcmd

c_2rel		lda	ctrlshadow2
		and	#$fe
		sta	$d40b
		jmp	postcmd

c_crel		lda	ctrlshadow2
		and	#$fe
		sta	$d40b
		lda	ctrlshadow
		and	#$fe
		sta	$d404
		;drop through

c_3rel		lda	ctrlshadow3
		and	#$fe
		sta	$d412
		jmp	postcmd


c_3arp		jsr	getbyte
		sta	arpnotes
		jsr	getbyte
		sta	arpnotes+1
		jsr	getbyte
		sta	arpnotes+2
		jmp	postcmd

c_vol		jsr	getbyte
		sta	$d418
		jmp	postcmd

c_pul		lda	#$41
		sta	ctrlshadow
		sta	$d404
		sta	$d40b
		sta	$d412
		jmp	postcmd

c_2pul		lda	#$41
		sta	ctrlshadow2
		sta	$d40b
		jmp	postcmd

c_pw		jsr	getbyte
		pha
		asl
		asl
		asl
		asl
		sta	pwidth
		sta	pwidth2
		sta	pwidth3
		pla
		lsr
		lsr
		lsr
		lsr
		sta	pwidth+1
		sta	pwidth2+1
		sta	pwidth3+1
		jmp	postcmd

c_filter	jsr	getbyte
		sta	$d417
		jmp	postcmd

c_cuto		jsr	getbyte
		sta	cutoff+1
		jmp	postcmd

c_cutod		jsr	getbyte
		sta	cutoffd
		.(
		eor	#0
		bmi	s1
		lda	#0
		jmp	s2
s1		lda	#$ff
s2		sta	cutoffd+1
		.)
		jmp	postcmd

c_vspeed	jsr	getbyte
		sta	vibrdelta
		jmp	postcmd

c_2vspeed	jsr	getbyte
		sta	vibrdelta2
		jmp	postcmd

c_3vspeed	jsr	getbyte
		sta	vibrdelta3
		jmp	postcmd

c_reset		jsr	sidreset
		jmp	postcmd

c_pwd		jsr	getbyte
		sta	pwidthd
		jmp	postcmd

c_2pwd		jsr	getbyte
		sta	pwidthd2
		jmp	postcmd

c_3pwd		jsr	getbyte
		sta	pwidthd3
		jmp	postcmd

c_transph	jsr	getbyte
		sta	transpoffs+1
		jmp	postcmd

c_transpdh	jsr	getbyte
		sta	transpdelta+1
		jmp	postcmd

c_transpdl	jsr	getbyte
		sta	transpdelta
		jmp	postcmd

c_transpl	jsr	getbyte
		sta	transpoffs
		jmp	postcmd

c_jump 		lda	#>jumphere
		sta	seqptr+1
		lda	#<jumphere
		sta	seqptr
		jmp	postcmd

c_tempo		jsr	getbyte
		sta	$dc05
		lda	#$0
		sta	$dc04
		jmp	postcmd

c_chord		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq
		lda	hifreq,x
		sta	basefreq+1
		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq2
		lda	hifreq,x
		sta	basefreq2+1
		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq3
		lda	hifreq,x
		sta	basefreq3+1
		lda	#6
		sta	vibrdepth
		lda	#4
		sta	vibrdelay
		jmp	postcmd

c_tr		jsr	getbyte
		sta	trnotes
		jsr	getbyte
		sta	trnotes+1
		lda	#0
		sta	trpos
		sta	trpos2
		sta	trpos3
		jmp	postcmd

c_anote		jsr	getbyte
		tax
		lda	lofreq,x
		sta	basefreq
		sta	basefreq2
		lda	lofreq,x
		sta	basefreq3
		lda	hifreq,x
		sta	basefreq+1
		sta	basefreq2+1
		lda	hifreq,x
		sta	basefreq3+1
		lda	#$f0
		sta	$d401
		lda	#$81
		sta	$d404
		.(
		ldx	#$00
s1		nop
		nop
		nop
		dex
		bne	s1
		.)
		lda	ctrlshadow
		sta	$d404
		jmp	postcmd


getbyte		.(
		ldy	#0
		lda	(seqptr),y
		inc	seqptr
		bne	s1
		inc	seqptr+1
s1		rts
		.)

		.)

initroutine:	.(
		lda	#>sequence
		sta	seqptr+1
		lda	#<sequence
		sta	seqptr
		jsr	sidreset
		lda	#$f
		sta	$d418
		lda	#$5c
		sta	$dc05
		lda	#$0
		sta	$dc04
		rts
		.)

sidreset	.(
		ldx	#$18
		lda	#0
lp		sta	$d400,x
		dex
		bpl	lp
		rts
		.)
sequence:	
		.byt	_VOL,$05

		.byt	10,_NOP

		;.byt	0,_JUMP

		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	4,_NOP
		.byt	1,_NOP
		.byt	5,_NOP
		.byt	5,_NOP
		.byt	10,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	20,_NOP
		.byt	10,_NOP
		.byt	6,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	12,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	10,_NOP
		.byt	15,_NOP
		.byt	10,_NOP

		; 1 bar before (1)
		.byt	17,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	2,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	2,_NOP

		.byt	14,_NOP
		.byt	10,_NOP
		.byt	15,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	4,_NOP
		.byt	4,_NOP
		.byt	2,_NOP
		.byt	2,_NOP
		.byt	4,_NOP
		.byt	4,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	12,_NOP
		.byt	10,_NOP
		.byt	15,_NOP
		.byt	10,_NOP
		.byt	15,_NOP
		.byt	4,_NOP
		.byt	4,_NOP
		.byt	2,_NOP
		.byt	2,_NOP
		.byt	4,_NOP
		.byt	4,_NOP
		.byt	4,_NOP

		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	3,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	10,_NOP
		.byt	2,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	12,_NOP
		.byt	4,_NOP
		.byt	8,_NOP
		.byt	4,_NOP
		.byt	10,_NOP

		.byt	2,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP
		.byt	16,_NOP
		.byt	10,_NOP
		.byt	14,_NOP
		.byt	8,_NOP


		; 1 bar before (3)
;jumphere:
		.byt	0,_TEMPO,$53
		.byt	25,_NOP
		.byt	16,_NOP

		.byt	72,_NOP

		.byt	72,_NOP
		.byt	72,_NOP
		.byt	48,_NOP
		.byt	24,_NOP
		.byt	72,_NOP

		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		
		.byt	72,_NOP
		.byt	48,_NOP
		.byt	24,_NOP

		.byt	72,_NOP
		.byt	72,_NOP

		.byt	72,_NOP
		.byt	72,_NOP

		.byt	72,_NOP

		.byt	36,_NOP

		.byt	36,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
;jumphere:
		;piu mosso

		.byt	13,_TEMPO,$4c
		.byt	59,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP

jumphere:	
		.byt	0,_TEMPO,$4c
		.byt	46,_NOP

		.byt	0,_AD,$83
		.byt	0,_DEPTH,2
		.byt	0,_VSPEED,30
		.byt	0,_2VSPEED,35
		.byt	0,_3VSPEED,24
		.byt	0,_VRESTART
		.byt	0,_SR,$fa
		.byt	0,_NOP
		.byt	0,_PW,10
		.byt	0,_PWD,3
		.byt	0,_2PWD,4
		.byt	0,_3PWD,5
		.byt	0,_NOP
		.byt	9,_TEMPO,$50
		.byt	25,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	7,_REL
		.byt	0,_AD,$83
		.byt	7,_SQ
		.byt	7,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_CHORD,59,61,65
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	36,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,59,61,65
		.byt	0,_SQ
		.byt	60,_REL
		.byt	12,_SR,$f8
		.byt	12,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	0,_SR,$fa
		.byt	6,_REL
		.byt	6,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,58,61,69
		.byt	0,_SQ
		.byt	36,_REL
		.byt	12,_CHORD,58,61,67
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,58,64,66
		.byt	0,_SQ
		.byt	60,_REL
		.byt	12,_SQ
		.byt	48,_REL
		.byt	24,_NOP

		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP
		.byt	72,_NOP

		.byt	0,_AD,$83
		.byt	13,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	7,_REL
		.byt	0,_AD,$83
		.byt	7,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	6,_REL
		.byt	6,_CHORD,59,61,65
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	36,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,59,61,65
		.byt	0,_SQ
		.byt	60,_REL
		.byt	12,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	36,_REL
		.byt	12,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,58,61,69
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_SQ,
		.byt	12,_REL
		.byt	12,_CHORD,58,61,67
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_CHORD,58,64,66
		.byt	0,_SQ
		.byt	60,_REL
		.byt	12,_SQ
		.byt	48,_REL
		.byt	24,_NOP

		.byt	72,_NOP
		.byt	72,_NOP

		.byt	0,_VOL,$06
		.byt	0,_AD,$93
		.byt	0,_SR,$db
		.byt	0,_CHORD,57,62,62
		.byt	0,_SQ
		.byt	12,_REL
		.byt	0,_AD,$63
		.byt	12,_SQ
		.byt	0,_CHORD,57,64,64
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,65,65
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,64,64
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,62,62
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,62,65,65
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,60,64,64
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,57,62,62
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,57,63,63
		.byt	24,_REL
		.byt	12,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,59,59
		.byt	12,_REL
		.byt	24,_SQ
		.byt	0,_CHORD,59,59,59
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,59,61,61
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,59,63,63
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,59,64,64
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,59,66,66
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,64,67,67
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,66,66
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,64,64
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,60,63,63
		.byt	24,_REL
		.byt	12,_CHORD,60,64,64
		.byt	0,_SQ
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,63,63
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,56,62,62
		.byt	72,_NOP
		.byt	48,_REL
		.byt	24,_NOP

		.byt	0,_VOL,$08
		.byt	0,_CHORD,57,60,64
		.byt	0,_SQ
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,57,60,66
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,60,67
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,60,66
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,60,64
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,57,60,67
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,60,64,66
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,57,60,64
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,58,64,66
		.byt	24,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,58,61,61
		.byt	6,_REL
		.byt	6,_SQ
		.byt	12,_REL
		.byt	24,_SQ
		.byt	0,_VOL,$0a
		.byt	0,_CHORD,58,61,61
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,58,62,62
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,58,64,64
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,58,62,62
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,58,61,61
		.byt	6,_REL
		.byt	6,_SQ
		.byt	0,_CHORD,59,62,66
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,62,65
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,62,66
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,65,69
		.byt	24,_NOP
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,59,65,67
		.byt	12,_REL
		.byt	12,_SQ
		.byt	0,_CHORD,58,64,66
		.byt	72,_NOP
		.byt	48,_REL
		.byt	24,_NOP

;jumphere:	;allegro
		.byt	0,_VOL,$0b
		.byt	0,_TEMPO,$28
		.byt	0,_AD,$c0
		.byt	0,_SR,$fd
		.byt	0,_CHORD,59,63,66
		.byt	0,_SQ
		.byt	72,_NOP
		.byt	65,_REL
		.byt	7,_CHORD,58,64,67
		.byt	72,_NOP
		.byt	72,_CHORD,59,63,66
		.byt	0,_AD,$d0
		.byt	0,_SQ
		.byt	72,_NOP
		.byt	65,_REL
		.byt	7,_CHORD,58,64,67
		.byt	72,_NOP
		.byt	0,_AD,$df
		.byt	72,_CHORD,59,62,66
		.byt	0,_SQ
		.byt	72,_NOP
		.byt	72,_CHORD,58,64,67
		.byt	0,_SR,$fe
		.byt	0,_REL
		.byt	72,_CHORD,59,62,66
		.byt	31,_SR,$fc
		.byt	65,_NOP
		.byt	65,_NOP
		.byt	0,_CHORD,58,64,67
		.byt	0,_AD,$df
		.byt	0,_SQ
		.byt	0,_SR,$fd
		.byt	79,_REL
		.byt	72,_CHORD,59,63,66
		.byt	24,_SR,$fa

		.byt	2,_END

basefreq:	.word	0
basefreq2:	.word	0
basefreq3:	.word	0
vibroffs:	.word	0
vibroffs2:	.word	0
vibroffs3:	.word	0
transpoffs:	.word	0
transpdelta:	.word	0

pwidth		.word	$600
pwidth2		.word	$600
pwidth3		.word	$600
pwidthd		.word	0
pwidthd2	.word	0
pwidthd3	.word	0

cutoff		.word	$d000
cutoffd		.word	0

timeleft:	.byt	20
playflag:	.byt	1

vibrdelta:	.byt	10
vibrdelta2:	.byt	10
vibrdelta3:	.byt	10
vibrpos:	.byt	0
vibrpos2:	.byt	0
vibrpos3:	.byt	0
vibrdepth:	.byt	6
vibrdepth2:	.byt	6
vibrdepth3:	.byt	6

vibrdelay	.byt	0
dvibrdepth:	.byt	6

ctrlshadow	.byt	0
ctrlshadow2	.byt	0
ctrlshadow3	.byt	0

arpnotes	.byt	0,0,0
arppos		.byt	1

trnotes		.byt	0,0

trpos		.byt	0
trpos2		.byt	0
trpos3		.byt	0

trscheme	.byt	0,0,0,0,1,1,0,0,0,0,1,0,0,0,1,$ff
trscheme2	.byt	0,0,0,1,0,0,0,0,1,1,0,0,1,$ff
trscheme3	.byt	0,0,1,0,0,1,0,0,1,0,0,1,0,0,1,$ff

sinvibr:
        .byt    $0,$0,$0,$0,$0,$0,$1,$1,$2,$3,$3,$4,$5,$6,$7,$8
        .byt    $9,$a,$c,$d,$e,$10,$12,$13,$15,$17,$18,$1a,$1c,$1e,$20,$23
        .byt    $25,$27,$29,$2c,$2e,$30,$33,$35,$38,$3b,$3d,$40,$43,$45,$48,$4b
        .byt    $4e,$51,$54,$57,$5a,$5d,$60,$63,$66,$69,$6c,$6f,$72,$75,$78,$7b
        .byt    $7e,$82,$85,$88,$8b,$8e,$91,$94,$97,$9a,$9d,$a0,$a3,$a6,$a9,$ac
        .byt    $af,$b2,$b5,$b8,$ba,$bd,$c0,$c2,$c5,$c8,$ca,$cd,$cf,$d1,$d4,$d6
        .byt    $d8,$da,$dd,$df,$e1,$e3,$e5,$e6,$e8,$ea,$eb,$ed,$ef,$f0,$f1,$f3
        .byt    $f4,$f5,$f6,$f7,$f8,$f9,$fa,$fa,$fb,$fc,$fc,$fd,$fd,$fd,$fd,$fd
        .byt    $fe,$fd,$fd,$fd,$fd,$fd,$fc,$fc,$fb,$fa,$fa,$f9,$f8,$f7,$f6,$f5
        .byt    $f4,$f3,$f1,$f0,$ef,$ed,$eb,$ea,$e8,$e6,$e5,$e3,$e1,$df,$dd,$da
        .byt    $d8,$d6,$d4,$d1,$cf,$cd,$ca,$c8,$c5,$c2,$c0,$bd,$ba,$b8,$b5,$b2
        .byt    $af,$ac,$a9,$a6,$a3,$a0,$9d,$9a,$97,$94,$91,$8e,$8b,$88,$85,$82
        .byt    $7f,$7b,$78,$75,$72,$6f,$6c,$69,$66,$63,$60,$5d,$5a,$57,$54,$51
        .byt    $4e,$4b,$48,$45,$43,$40,$3d,$3b,$38,$35,$33,$30,$2e,$2c,$29,$27
        .byt    $25,$23,$20,$1e,$1c,$1a,$18,$17,$15,$13,$12,$10,$e,$d,$c,$a
        .byt    $9,$8,$7,$6,$5,$4,$3,$3,$2,$1,$1,$0,$0,$0,$0,$0

hifreq:
	.byt	$01,$01,$01,$01,$01
	.byt	$01,$01,$01,$01,$01,$01
	.byt	$02,$02,$02,$02,$02,$02
	.byt	$02,$03,$03,$03,$03,$03
	.byt	$04,$04,$04,$04,$05,$05
	.byt	$05,$06,$06,$06,$07,$07
	.byt	$08,$08,$09,$09,$0a,$0a
	.byt	$0b,$0c,$0d,$0d,$0e,$0f
	.byt	$10,$11,$12,$13,$14,$15
	.byt	$17,$18,$1a,$1b,$1d,$1f
	.byt	$20,$22,$24,$27,$29,$2b
	.byt	$2e,$31,$34,$37,$3a,$3e
	.byt	$41,$45,$49,$4e,$52,$57
	.byt	$5c,$62,$68,$6e,$75,$7c
	.byt	$83,$8b,$93,$9c,$a5,$af
	.byt	$b9,$c4,$d0,$dd,$ea,$f8

lofreq:
	.byt	$16,$27,$38,$4b,$5e
	.byt	$73,$89,$a1,$ba,$d4,$f0
	.byt	$0d,$2c,$4e,$71,$96,$bd
	.byt	$e7,$13,$42,$74,$a8,$e0
	.byt	$1b,$59,$9c,$e2,$2c,$7b
	.byt	$ce,$27,$84,$e8,$51,$c0
	.byt	$36,$b3,$38,$c4,$59,$f6
	.byt	$9d,$4e,$09,$d0,$a2,$81
	.byt	$6d,$67,$70,$88,$b2,$ed
	.byt	$3a,$9c,$13,$a0,$44,$02
	.byt	$da,$ce,$e0,$11,$64,$da
	.byt	$75,$38,$26,$40,$89,$04
	.byt	$b4,$9c,$c0,$22,$c8,$b4
	.byt	$eb,$71,$4c,$80,$12,$08
	.byt	$68,$38,$80,$45,$90,$68
	.byt	$d6,$e3,$98,$00,$24,$10



